Index: src/edu/ucsb/nceas/metacat/MetaCatServlet.java
===================================================================
--- src/edu/ucsb/nceas/metacat/MetaCatServlet.java	(revision 5029)
+++ src/edu/ucsb/nceas/metacat/MetaCatServlet.java	(revision 5030)
@@ -78,14 +78,15 @@
 import edu.ucsb.nceas.metacat.database.DBConnectionPool;
 import edu.ucsb.nceas.metacat.database.DatabaseService;
 import edu.ucsb.nceas.metacat.dataquery.DataQuery;
+import edu.ucsb.nceas.metacat.properties.PropertyService;
+import edu.ucsb.nceas.metacat.properties.SkinPropertyService;
 import edu.ucsb.nceas.metacat.replication.ForceReplicationHandler;
 import edu.ucsb.nceas.metacat.replication.ReplicationService;
 import edu.ucsb.nceas.metacat.scheduler.SchedulerService;
-import edu.ucsb.nceas.metacat.service.PropertyService;
 import edu.ucsb.nceas.metacat.service.ServiceService;
 import edu.ucsb.nceas.metacat.service.SessionService;
-import edu.ucsb.nceas.metacat.service.SkinPropertyService;
 import edu.ucsb.nceas.metacat.service.XMLSchemaService;
+import edu.ucsb.nceas.metacat.shared.BaseException;
 import edu.ucsb.nceas.metacat.shared.HandlerException;
 import edu.ucsb.nceas.metacat.shared.MetacatUtilException;
 import edu.ucsb.nceas.metacat.shared.ServiceException;
@@ -97,8 +98,10 @@
 import edu.ucsb.nceas.metacat.util.DocumentUtil;
 import edu.ucsb.nceas.metacat.util.MetacatUtil;
 import edu.ucsb.nceas.metacat.util.RequestUtil;
+import edu.ucsb.nceas.metacat.util.ResponseUtil;
 import edu.ucsb.nceas.metacat.util.SystemUtil;
 import edu.ucsb.nceas.metacat.util.SessionData;
+import edu.ucsb.nceas.metacat.workflow.WorkflowSchedulerClient;
 import edu.ucsb.nceas.utilities.FileUtil;
 import edu.ucsb.nceas.utilities.GeneralPropertyException;
 import edu.ucsb.nceas.utilities.LSIDUtil;
@@ -294,6 +297,7 @@
     private static final String FALSE = "false";
     private static final String TRUE  = "true";
     private static String LOG_CONFIG_NAME = null;
+    public static final String APPLICATION_NAME = "metacat";
     
     /**
      * Initialize the servlet by creating appropriate database connections
@@ -308,6 +312,7 @@
             super.init(config);
             
             ServletContext context = config.getServletContext();
+            context.setAttribute("APPLICATION_NAME", APPLICATION_NAME);
             
             ServiceService serviceService = ServiceService.getInstance(context);
             logMetacat.debug("ServiceService singleton created " + serviceService);
@@ -319,7 +324,7 @@
             PropertyConfigurator.configureAndWatch(LOG_CONFIG_NAME);
             
             // Register preliminary services
-            ServiceService.registerService("PropertyService", PropertyService.getInstance());         
+            ServiceService.registerService("PropertyService", PropertyService.getInstance(context));         
             ServiceService.registerService("SkinPropertyService", SkinPropertyService.getInstance());
             ServiceService.registerService("SessionService", SessionService.getInstance()); 
             
@@ -701,381 +706,385 @@
 			String ctype = request.getContentType();
 			if (ctype != null && ctype.startsWith("multipart/form-data")) {
 				handleMultipartForm(request, response);
-			} else {
+				return;
+			} 
 
-				String name = null;
-				String[] value = null;
-				String[] docid = new String[3];
-				Hashtable<String, String[]> params = new Hashtable<String, String[]>();
+			String name = null;
+			String[] value = null;
+			String[] docid = new String[3];
+			Hashtable<String, String[]> params = new Hashtable<String, String[]>();
 
-				// Check if this is a simple read request that doesn't use the
-				// "action" syntax
-				// These URLs are of the form:
-				// http://localhost:8180/knb/metacat/docid/skinname
-				// e.g., http://localhost:8180/knb/metacat/test.1.1/knb
-				String pathInfo = request.getPathInfo();
-				if (pathInfo != null) {
-					String[] path = pathInfo.split("/");
-					if (path.length > 1) {
-						String docidToRead = path[1];
-						String docs[] = new String[1];
-						docs[0] = docidToRead;
-						logMetacat.debug("READING DOCID FROM PATHINFO: " + docs[0]);
-						params.put("docid", docs);
-						String skin = null;
-						if (path.length > 2) {
-							skin = path[2];
-							String skins[] = new String[1];
-							skins[0] = skin;
-							params.put("qformat", skins);
-						}
-						handleReadAction(params, request, response, "public", null, null);
-						return;
+			// Check if this is a simple read request that doesn't use the
+			// "action" syntax
+			// These URLs are of the form:
+			// http://localhost:8180/knb/metacat/docid/skinname
+			// e.g., http://localhost:8180/knb/metacat/test.1.1/knb
+			String pathInfo = request.getPathInfo();
+			if (pathInfo != null) {
+				String[] path = pathInfo.split("/");
+				if (path.length > 1) {
+					String docidToRead = path[1];
+					String docs[] = new String[1];
+					docs[0] = docidToRead;
+					logMetacat.debug("READING DOCID FROM PATHINFO: " + docs[0]);
+					params.put("docid", docs);
+					String skin = null;
+					if (path.length > 2) {
+						skin = path[2];
+						String skins[] = new String[1];
+						skins[0] = skin;
+						params.put("qformat", skins);
 					}
+					handleReadAction(params, request, response, "public", null, null);
+					return;
 				}
+			}
 
-				Enumeration<String> paramlist =(Enumeration<String>)request.getParameterNames();
-				while (paramlist.hasMoreElements()) {
+			Enumeration<String> paramlist = 
+				(Enumeration<String>) request.getParameterNames();
+			while (paramlist.hasMoreElements()) {
 
-					name = paramlist.nextElement();
-					value = request.getParameterValues(name);
+				name = paramlist.nextElement();
+				value = request.getParameterValues(name);
 
-					// Decode the docid and mouse click information
-					// THIS IS OBSOLETE -- I THINK -- REMOVE THIS BLOCK
-					// 4/12/2007d
-					// MBJ
-					if (name.endsWith(".y")) {
-						docid[0] = name.substring(0, name.length() - 2);
-						params.put("docid", docid);
-						name = "ypos";
-					}
-					if (name.endsWith(".x")) {
-						name = "xpos";
-					}
-
-					params.put(name, value);
+				// Decode the docid and mouse click information
+				// THIS IS OBSOLETE -- I THINK -- REMOVE THIS BLOCK
+				// 4/12/2007d
+				// MBJ
+				if (name.endsWith(".y")) {
+					docid[0] = name.substring(0, name.length() - 2);
+					params.put("docid", docid);
+					name = "ypos";
 				}
-
-				// handle param is emptpy
-				if (params.isEmpty() || params == null) {
-					return;
+				if (name.endsWith(".x")) {
+					name = "xpos";
 				}
 
-				// if the user clicked on the input images, decode which image
-				// was clicked then set the action.
-				if (params.get("action") == null) {
-					PrintWriter out = response.getWriter();
-					response.setContentType("text/xml");
-					out.println("<?xml version=\"1.0\"?>");
-					out.println("<error>");
-					out.println("Action not specified");
-					out.println("</error>");
-					out.close();
-					return;
-				}
+				params.put(name, value);
+			}
 
-				String action = (params.get("action"))[0];
-				logMetacat.info("Action is: " + action);
+			// handle param is emptpy
+			if (params.isEmpty() || params == null) {
+				return;
+			}
 
-				// This block handles session management for the servlet
-				// by looking up the current session information for all actions
-				// other than "login" and "logout"
-				String userName = null;
-				String password = null;
-				String[] groupNames = null;
-				String sessionId = null;
-				name = null;
+			// if the user clicked on the input images, decode which image
+			// was clicked then set the action.
+			if (params.get("action") == null) {
+				PrintWriter out = response.getWriter();
+				response.setContentType("text/xml");
+				out.println("<?xml version=\"1.0\"?>");
+				out.println("<error>");
+				out.println("Action not specified");
+				out.println("</error>");
+				out.close();
+				return;
+			}
 
-				// handle login action
-				if (action.equals("login")) {
-					PrintWriter out = response.getWriter();
-					handleLoginAction(out, params, request, response);
-					out.close();
+			String action = (params.get("action"))[0];
+			logMetacat.info("Action is: " + action);
 
-					// handle logout action
-				} else if (action.equals("logout")) {
-					PrintWriter out = response.getWriter();
-					handleLogoutAction(out, params, request, response);
-					out.close();
+			// This block handles session management for the servlet
+			// by looking up the current session information for all actions
+			// other than "login" and "logout"
+			String userName = null;
+			String password = null;
+			String[] groupNames = null;
+			String sessionId = null;
+			name = null;
 
-					// handle shrink DBConnection request
-				} else if (action.equals("shrink")) {
-					PrintWriter out = response.getWriter();
-					boolean success = false;
-					// If all DBConnection in the pool are free and DBConnection pool
-					// size is greater than initial value, shrink the connection pool
-					// size to initial value
-					success = DBConnectionPool.shrinkConnectionPoolSize();
-					if (success) {
-						// if successfully shrink the pool size to initial value
-						out.println("DBConnection Pool shrunk successfully.");
-					}// if
-					else {
-						out.println("DBConnection pool not shrunk successfully.");
-					}
-					// close out put
-					out.close();
+			// handle login action
+			if (action.equals("login")) {
+				PrintWriter out = response.getWriter();
+				handleLoginAction(out, params, request, response);
+				out.close();
 
-					// aware of session expiration on every request
-				} else {
-					SessionData sessionData = RequestUtil.getSessionData(request);
-					
-					userName = sessionData.getUserName();
-					password = sessionData.getPassword();
-					groupNames = sessionData.getGroupNames();
-					sessionId = sessionData.getId();
+				// handle logout action
+			} else if (action.equals("logout")) {
+				PrintWriter out = response.getWriter();
+				handleLogoutAction(out, params, request, response);
+				out.close();
 
-					logMetacat.info("The user is : " + userName);
+				// handle shrink DBConnection request
+			} else if (action.equals("shrink")) {
+				PrintWriter out = response.getWriter();
+				boolean success = false;
+				// If all DBConnection in the pool are free and DBConnection
+				// pool
+				// size is greater than initial value, shrink the connection
+				// pool
+				// size to initial value
+				success = DBConnectionPool.shrinkConnectionPoolSize();
+				if (success) {
+					// if successfully shrink the pool size to initial value
+					out.println("DBConnection Pool shrunk successfully.");
+				}// if
+				else {
+					out.println("DBConnection pool not shrunk successfully.");
 				}
-				// Now that we know the session is valid, we can delegate the
-				// request to a particular action handler
-				if (action.equals("query")) {
-					ServletOutputStream streamOut = response.getOutputStream();
-					PrintWriter out = new PrintWriter(streamOut);
-					handleQuery(out, params, response, userName, groupNames, sessionId);
-					out.close();
-				} else if (action.equals("squery")) {
-					ServletOutputStream streamOut = response.getOutputStream();
-					PrintWriter out = new PrintWriter(streamOut);
-					if (params.containsKey("query")) {
-						handleSQuery(out, params, response, userName, groupNames, sessionId);
-						out.close();
-					} else {
-						out.println("Illegal action squery without \"query\" parameter");
-						out.close();
-					}
-				} else if (action.trim().equals("spatial_query")) {
+				// close out put
+				out.close();
 
-					logMetacat
-							.debug("******************* SPATIAL QUERY ********************");
-					ServletOutputStream streamOut = response.getOutputStream();
-					PrintWriter out = new PrintWriter(streamOut);
-					handleSpatialQuery(out, params, response, userName, groupNames,
-							sessionId);
-					out.close();
+				// aware of session expiration on every request
+			} else {
+				SessionData sessionData = RequestUtil.getSessionData(request);
 
-				} 
-				else if (action.trim().equals("dataquery")) {
+				userName = sessionData.getUserName();
+				password = sessionData.getPassword();
+				groupNames = sessionData.getGroupNames();
+				sessionId = sessionData.getId();
 
-					logMetacat
-							.debug("******************* DATA QUERY ********************");
-					handleDataquery(params, response, sessionId);
+				logMetacat.info("The user is : " + userName);
+			}
+			// Now that we know the session is valid, we can delegate the
+			// request to a particular action handler
+			if (action.equals("query")) {
+				ServletOutputStream streamOut = response.getOutputStream();
+				PrintWriter out = new PrintWriter(streamOut);
+				handleQuery(out, params, response, userName, groupNames, sessionId);
+				out.close();
+			} else if (action.equals("squery")) {
+				ServletOutputStream streamOut = response.getOutputStream();
+				PrintWriter out = new PrintWriter(streamOut);
+				if (params.containsKey("query")) {
+					handleSQuery(out, params, response, userName, groupNames, sessionId);
+					out.close();
+				} else {
+					out.println("Illegal action squery without \"query\" parameter");
+					out.close();
 				}
-				else if (action.trim().equals("editcart")) {
-					logMetacat
-							.debug("******************* EDIT CART ********************");
-					handleEditCart(params, response, sessionId);
-				}
-				else if (action.equals("export")) {
+			} else if (action.trim().equals("spatial_query")) {
 
-					handleExportAction(params, response, userName, groupNames, password);
-				} else if (action.equals("read")) {
-					if (params.get("archiveEntryName") != null) {
-						ArchiveHandler.getInstance().readArchiveEntry(params, request, response, 
-								userName, password,groupNames);
-					} else {
-						handleReadAction(params, request, response, userName, password,
-								groupNames);
-					}
-				} else if (action.equals("readinlinedata")) {
-					handleReadInlineDataAction(params, request, response, userName,
-							password, groupNames);
-				} else if (action.equals("insert") || action.equals("update")) {
-					PrintWriter out = response.getWriter();
-					if ((userName != null) && !userName.equals("public")) {
-						handleInsertOrUpdateAction(request, response, out, params,
-								userName, groupNames);
-					} else {
-						response.setContentType("text/xml");
-						out.println("<?xml version=\"1.0\"?>");
-						out.println("<error>");
-						out.println("Permission denied for user " + userName + " "
-								+ action);
-						out.println("</error>");
-					}
-					out.close();
-				} else if (action.equals("delete")) {
-					PrintWriter out = response.getWriter();
-					if ((userName != null) && !userName.equals("public")) {
-						handleDeleteAction(out, params, request, response, userName,
-								groupNames);
-					} else {
-						response.setContentType("text/xml");
-						out.println("<?xml version=\"1.0\"?>");
-						out.println("<error>");
-						out.println("Permission denied for " + action);
-						out.println("</error>");
-					}
-					out.close();
-				} else if (action.equals("validate")) {
-					PrintWriter out = response.getWriter();
-					handleValidateAction(out, params);
-					out.close();
-				} else if (action.equals("setaccess")) {
-					PrintWriter out = response.getWriter();
-					handleSetAccessAction(out, params, userName);
-					out.close();
-				} else if (action.equals("getaccesscontrol")) {
-					PrintWriter out = response.getWriter();
-					handleGetAccessControlAction(out, params, response, userName,
+				logMetacat
+						.debug("******************* SPATIAL QUERY ********************");
+				ServletOutputStream streamOut = response.getOutputStream();
+				PrintWriter out = new PrintWriter(streamOut);
+				handleSpatialQuery(out, params, response, userName, groupNames, sessionId);
+				out.close();
+
+			} else if (action.trim().equals("dataquery")) {
+
+				logMetacat.debug("******************* DATA QUERY ********************");
+				handleDataquery(params, response, sessionId);
+			} else if (action.trim().equals("editcart")) {
+				logMetacat.debug("******************* EDIT CART ********************");
+				handleEditCart(params, response, sessionId);
+			} else if (action.equals("export")) {
+
+				handleExportAction(params, response, userName, groupNames, password);
+			} else if (action.equals("read")) {
+				if (params.get("archiveEntryName") != null) {
+					ArchiveHandler.getInstance().readArchiveEntry(params, request,
+							response, userName, password, groupNames);
+				} else {
+					handleReadAction(params, request, response, userName, password,
 							groupNames);
-					out.close();
-				} else if (action.equals("getprincipals")) {
-					PrintWriter out = response.getWriter();
-					handleGetPrincipalsAction(out, userName, password);
-					out.close();
-				} else if (action.equals("getdoctypes")) {
-					PrintWriter out = response.getWriter();
-					handleGetDoctypesAction(out, params, response);
-					out.close();
-				} else if (action.equals("getdtdschema")) {
-					PrintWriter out = response.getWriter();
-					handleGetDTDSchemaAction(out, params, response);
-					out.close();
-				} else if (action.equals("getlastdocid")) {
-					PrintWriter out = response.getWriter();
-					handleGetMaxDocidAction(out, params, response);
-					out.close();
-				} else if (action.equals("getalldocids")) {
-					PrintWriter out = response.getWriter();
-					handleGetAllDocidsAction(out, params, response);
-					out.close();
-				} else if (action.equals("isregistered")) {
-					PrintWriter out = response.getWriter();
-					handleIdIsRegisteredAction(out, params, response);
-					out.close();
-				} else if (action.equals("getrevisionanddoctype")) {
-					PrintWriter out = response.getWriter();
-					handleGetRevisionAndDocTypeAction(out, params);
-					out.close();
-				} else if (action.equals("getversion")) {
+				}
+			} else if (action.equals("readinlinedata")) {
+				handleReadInlineDataAction(params, request, response, userName, password,
+						groupNames);
+			} else if (action.equals("insert") || action.equals("update")) {
+				PrintWriter out = response.getWriter();
+				if ((userName != null) && !userName.equals("public")) {
+					handleInsertOrUpdateAction(request, response, out, params, userName,
+							groupNames);
+				} else {
 					response.setContentType("text/xml");
-					PrintWriter out = response.getWriter();
-					out.println(MetacatVersion.getVersionAsXml());
-					out.close();
-				} else if (action.equals("getlog")) {
-					handleGetLogAction(params, request, response, userName, groupNames);
-				} else if (action.equals("getloggedinuserinfo")) {
-					PrintWriter out = response.getWriter();
-					response.setContentType("text/xml");
 					out.println("<?xml version=\"1.0\"?>");
-					out.println("\n<user>\n");
-					out.println("\n<username>\n");
-					out.println(userName);
-					out.println("\n</username>\n");
-					if (name != null) {
-						out.println("\n<name>\n");
-						out.println(name);
-						out.println("\n</name>\n");
-					}
-					if (AuthUtil.isAdministrator(userName, groupNames)) {
-						out.println("<isAdministrator></isAdministrator>\n");
-					}
-					if (AuthUtil.isModerator(userName, groupNames)) {
-						out.println("<isModerator></isModerator>\n");
-					}
-					out.println("\n</user>\n");
-					out.close();
-				} else if (action.equals("buildindex")) {
-					handleBuildIndexAction(params, request, response, userName,
+					out.println("<error>");
+					out.println("Permission denied for user " + userName + " " + action);
+					out.println("</error>");
+				}
+				out.close();
+			} else if (action.equals("delete")) {
+				PrintWriter out = response.getWriter();
+				if ((userName != null) && !userName.equals("public")) {
+					handleDeleteAction(out, params, request, response, userName,
 							groupNames);
-				} else if (action.equals("login") || action.equals("logout")) {
-					/*
-					 * } else if (action.equals("protocoltest")) { String
-					 * testURL = "metacat://dev.nceas.ucsb.edu/NCEAS.897766.9";
-					 * try { testURL = ((String[]) params.get("url"))[0]; }
-					 * catch (Throwable t) { } String phandler = System
-					 * .getProperty("java.protocol.handler.pkgs");
-					 * response.setContentType("text/html"); PrintWriter out =
-					 * response.getWriter(); out.println("<body
-					 * bgcolor=\"white\">"); out.println("<p>Handler property:
-					 * <code>" + phandler + "</code></p>"); out.println("<p>Starting
-					 * test for:<br>"); out.println(" " + testURL + "</p>");
-					 * try { URL u = new URL(testURL); out.println("<pre>");
-					 * out.println("Protocol: " + u.getProtocol());
-					 * out.println(" Host: " + u.getHost()); out.println(" Port: " +
-					 * u.getPort()); out.println(" Path: " + u.getPath());
-					 * out.println(" Ref: " + u.getRef()); String pquery =
-					 * u.getQuery(); out.println(" Query: " + pquery);
-					 * out.println(" Params: "); if (pquery != null) { Hashtable
-					 * qparams = MetacatUtil.parseQuery(u.getQuery()); for
-					 * (Enumeration en = qparams.keys(); en .hasMoreElements();) {
-					 * String pname = (String) en.nextElement(); String pvalue =
-					 * (String) qparams.get(pname); out.println(" " + pname + ": " +
-					 * pvalue); } } out.println("</pre>"); out.println("</body>");
-					 * out.close(); } catch (MalformedURLException mue) {
-					 * System.out.println( "bad url from
-					 * MetacatServlet.handleGetOrPost");
-					 * out.println(mue.getMessage()); mue.printStackTrace(out);
-					 * out.close(); }
-					 */
-				} else if (action.equals("refreshServices")) {
-					// TODO MCD this interface is for testing.  It should go through a 
-					// ServiceService class and only work for an admin user.  Move to the
-					// MetacatAdminServlet
-					ServiceService.refreshService("XMLSchemaService");
-					return;
-//				} else if (action.equals("scheduleWorkflow")) {
-//					try {
-//						WorkflowScheduler.getInstance().scheduleJob(request, response, params, 
-//							userName, groupNames);
-//						return;
-//					} catch (BaseException be) {
-//						ResponseUtil.sendErrorXML(response, ResponseUtil.SCHEDULE_WORKFLOW_ERROR, be);
-//						return;						
-//					}
-//				} else if (action.equals("unscheduleWorkflow")) {
-//					try {
-//						WorkflowScheduler.getInstance().unScheduleJob(request, response, params, 
-//							userName, groupNames);
-//						return;
-//					} catch (BaseException be) {
-//						ResponseUtil.sendErrorXML(response, ResponseUtil.UNSCHEDULE_WORKFLOW_ERROR, be);
-//						return;						
-//					}
-//				} else if (action.equals("rescheduleWorkflow")) {
-//					try {
-//						WorkflowScheduler.getInstance().reScheduleJob(request, response, params, 
-//							userName, groupNames);
-//						return;
-//					} catch (BaseException be) {
-//						ResponseUtil.sendErrorXML(response, ResponseUtil.RESCHEDULE_WORKFLOW_ERROR, be);
-//						return;						
-//					}
-//				} else if (action.equals("getScheduledWorkflow")) {
-//					try {
-//						WorkflowScheduler.getInstance().getJobs(request, response, params, 
-//								userName, groupNames);				
-//						return;
-//					} catch (BaseException be) {
-//						ResponseUtil.sendErrorXML(response, ResponseUtil.GET_SCHEDULED_WORKFLOW_ERROR, be);
-//						return;						
-//					}
-//				} else if (action.equals("deleteScheduledWorkflow")) {
-//					try {
-//						WorkflowScheduler.getInstance().deleteJob(request, response, params, 
-//								userName, groupNames);				
-//						return;
-//					} catch (BaseException be) {
-//						ResponseUtil.sendErrorXML(response, ResponseUtil.DELETE_SCHEDULED_WORKFLOW_ERROR, be);
-//						return;						
-//					}
 				} else {
-					PrintWriter out = response.getWriter();
+					response.setContentType("text/xml");
 					out.println("<?xml version=\"1.0\"?>");
 					out.println("<error>");
-					out.println("Error: action not registered.  Please report this error.");
+					out.println("Permission denied for " + action);
 					out.println("</error>");
-					out.close();
 				}
+				out.close();
+			} else if (action.equals("validate")) {
+				PrintWriter out = response.getWriter();
+				handleValidateAction(out, params);
+				out.close();
+			} else if (action.equals("setaccess")) {
+				PrintWriter out = response.getWriter();
+				handleSetAccessAction(out, params, userName);
+				out.close();
+			} else if (action.equals("getaccesscontrol")) {
+				PrintWriter out = response.getWriter();
+				handleGetAccessControlAction(out, params, response, userName, groupNames);
+				out.close();
+			} else if (action.equals("getprincipals")) {
+				PrintWriter out = response.getWriter();
+				handleGetPrincipalsAction(out, userName, password);
+				out.close();
+			} else if (action.equals("getdoctypes")) {
+				PrintWriter out = response.getWriter();
+				handleGetDoctypesAction(out, params, response);
+				out.close();
+			} else if (action.equals("getdtdschema")) {
+				PrintWriter out = response.getWriter();
+				handleGetDTDSchemaAction(out, params, response);
+				out.close();
+			} else if (action.equals("getlastdocid")) {
+				PrintWriter out = response.getWriter();
+				handleGetMaxDocidAction(out, params, response);
+				out.close();
+			} else if (action.equals("getalldocids")) {
+				PrintWriter out = response.getWriter();
+				handleGetAllDocidsAction(out, params, response);
+				out.close();
+			} else if (action.equals("isregistered")) {
+				PrintWriter out = response.getWriter();
+				handleIdIsRegisteredAction(out, params, response);
+				out.close();
+			} else if (action.equals("getrevisionanddoctype")) {
+				PrintWriter out = response.getWriter();
+				handleGetRevisionAndDocTypeAction(out, params);
+				out.close();
+			} else if (action.equals("getversion")) {
+				response.setContentType("text/xml");
+				PrintWriter out = response.getWriter();
+				out.println(MetacatVersion.getVersionAsXml());
+				out.close();
+			} else if (action.equals("getlog")) {
+				handleGetLogAction(params, request, response, userName, groupNames);
+			} else if (action.equals("getloggedinuserinfo")) {
+				PrintWriter out = response.getWriter();
+				response.setContentType("text/xml");
+				out.println("<?xml version=\"1.0\"?>");
+				out.println("\n<user>\n");
+				out.println("\n<username>\n");
+				out.println(userName);
+				out.println("\n</username>\n");
+				if (name != null) {
+					out.println("\n<name>\n");
+					out.println(name);
+					out.println("\n</name>\n");
+				}
+				if (AuthUtil.isAdministrator(userName, groupNames)) {
+					out.println("<isAdministrator></isAdministrator>\n");
+				}
+				if (AuthUtil.isModerator(userName, groupNames)) {
+					out.println("<isModerator></isModerator>\n");
+				}
+				out.println("\n</user>\n");
+				out.close();
+			} else if (action.equals("buildindex")) {
+				handleBuildIndexAction(params, request, response, userName, groupNames);
+			} else if (action.equals("login") || action.equals("logout")) {
+				/*
+				 * } else if (action.equals("protocoltest")) { String testURL =
+				 * "metacat://dev.nceas.ucsb.edu/NCEAS.897766.9"; try { testURL =
+				 * ((String[]) params.get("url"))[0]; } catch (Throwable t) { }
+				 * String phandler = System
+				 * .getProperty("java.protocol.handler.pkgs");
+				 * response.setContentType("text/html"); PrintWriter out =
+				 * response.getWriter(); out.println("<body
+				 * bgcolor=\"white\">"); out.println("<p>Handler property:
+				 * <code>" + phandler + "</code></p>"); out.println("<p>Starting
+				 * test for:<br>"); out.println(" " + testURL + "</p>"); try {
+				 * URL u = new URL(testURL); out.println("<pre>");
+				 * out.println("Protocol: " + u.getProtocol()); out.println("
+				 * Host: " + u.getHost()); out.println(" Port: " + u.getPort());
+				 * out.println(" Path: " + u.getPath()); out.println(" Ref: " +
+				 * u.getRef()); String pquery = u.getQuery(); out.println("
+				 * Query: " + pquery); out.println(" Params: "); if (pquery !=
+				 * null) { Hashtable qparams =
+				 * MetacatUtil.parseQuery(u.getQuery()); for (Enumeration en =
+				 * qparams.keys(); en .hasMoreElements();) { String pname =
+				 * (String) en.nextElement(); String pvalue = (String)
+				 * qparams.get(pname); out.println(" " + pname + ": " + pvalue); } }
+				 * out.println("</pre>"); out.println("</body>");
+				 * out.close(); } catch (MalformedURLException mue) {
+				 * System.out.println( "bad url from
+				 * MetacatServlet.handleGetOrPost");
+				 * out.println(mue.getMessage()); mue.printStackTrace(out);
+				 * out.close(); }
+				 */
+			} else if (action.equals("refreshServices")) {
+				// TODO MCD this interface is for testing. It should go through
+				// a
+				// ServiceService class and only work for an admin user. Move to
+				// the
+				// MetacatAdminServlet
+				ServiceService.refreshService("XMLSchemaService");
+				return;
+			} else if (action.equals("scheduleWorkflow")) {
+				try {
+					WorkflowSchedulerClient.getInstance().scheduleJob(request, response,
+							params, userName, groupNames);
+					return;
+				} catch (BaseException be) {
+					ResponseUtil.sendErrorXML(response,
+							ResponseUtil.SCHEDULE_WORKFLOW_ERROR, be);
+					return;
+				}
+			} else if (action.equals("unscheduleWorkflow")) {
+				try {
+					WorkflowSchedulerClient.getInstance().unScheduleJob(request,
+							response, params, userName, groupNames);
+					return;
+				} catch (BaseException be) {
+					ResponseUtil.sendErrorXML(response,
+							ResponseUtil.UNSCHEDULE_WORKFLOW_ERROR, be);
+					return;
+				}
+			} else if (action.equals("rescheduleWorkflow")) {
+				try {
+					WorkflowSchedulerClient.getInstance().reScheduleJob(request,
+							response, params, userName, groupNames);
+					return;
+				} catch (BaseException be) {
+					ResponseUtil.sendErrorXML(response,
+							ResponseUtil.RESCHEDULE_WORKFLOW_ERROR, be);
+					return;
+				}
+			} else if (action.equals("getScheduledWorkflow")) {
+				try {
+					WorkflowSchedulerClient.getInstance().getJobs(request, response,
+							params, userName, groupNames);
+					return;
+				} catch (BaseException be) {
+					ResponseUtil.sendErrorXML(response,
+							ResponseUtil.GET_SCHEDULED_WORKFLOW_ERROR, be);
+					return;
+				}
+			} else if (action.equals("deleteScheduledWorkflow")) {
+				try {
+					WorkflowSchedulerClient.getInstance().deleteJob(request, response,
+							params, userName, groupNames);
+					return;
+				} catch (BaseException be) {
+					ResponseUtil.sendErrorXML(response,
+							ResponseUtil.DELETE_SCHEDULED_WORKFLOW_ERROR, be);
+					return;
+				}
 
-				// util.closeConnections();
-				// Close the stream to the client
-				// out.close();
+			} else {
+				PrintWriter out = response.getWriter();
+				out.println("<?xml version=\"1.0\"?>");
+				out.println("<error>");
+				out.println("Error: action not registered.  Please report this error.");
+				out.println("</error>");
+				out.close();
+			}
 
-				// Schedule the sitemap generator to run periodically
-				scheduleSitemapGeneration(request);
-			}
+			// util.closeConnections();
+			// Close the stream to the client
+			// out.close();
+
+			// Schedule the sitemap generator to run periodically
+			scheduleSitemapGeneration(request);
+
+
 		} catch (PropertyNotFoundException pnfe) {
 			String errorString = "Critical property not found: " + pnfe.getMessage();
 			logMetacat.error(errorString);
